/*
 * @Description: 测试车位分配模块通信情况
 * @Author: yct
 * @Date: 2020-07-08 15:51:46
 * @LastEditTime: 2020-09-18 11:21:22
 * @LastEditors: yct
 */ 
#include "../parkspace_allocation/parkspace_allocation_communicator.h"
#include "../parkspace_allocation/parkspace_allocator.h"
#include "../tool/proto_tool.h"

int main()
{
    google::InitGoogleLogging("parkspace_allocator");
    google::SetStderrLogging(google::INFO);
    google::InstallFailureSignalHandler();
    FLAGS_colorlogtostderr = true;

	parkspace_proto::garage_config config;//存放数据库连接信息
	proto_tool::get_instance_references().read_proto_param("../setting/parkspace_config.prototxt", config);//从目标文件读取数据库连接信息
	Parkspace_allocator::get_instance_references().parkspace_allocator_init(5, config);//初始化线程池
	Parkspace_allocation_communicator *p_parkspace_allocation_communicater = Parkspace_allocation_communicator::get_instance_pointer();//获取通信的单例

	p_parkspace_allocation_communicater->communication_bind("tcp://192.168.2.115:7001");//绑定地址
	p_parkspace_allocation_communicater->communication_run();//启动
	while(1)
	{
		sleep(1);
	}
	p_parkspace_allocation_communicater->communication_uninit();
	Parkspace_allocator::get_instance_references().parkspace_allocator_uninit();

//    parkspace_proto::garage_config config;
    // // parkspace_proto::database_config config;
//    // config.mutable_db_config()->set_db_ip("127.0.0.1");
//    // config.mutable_db_config()->set_db_port(3306);
//    // config.mutable_db_config()->set_db_username("yct");
//    // config.mutable_db_config()->set_db_passwd("123456");
//    // config.mutable_db_config()->set_db_name("test");
//    // config.mutable_db_config()->set_db_conn_pool_size(5);
//    // config.set_block_size(3);
//    // config.set_terminal_size_in_block(2);
//    proto_tool::get_instance_references().read_proto_param("../setting/parkspace_config.prototxt", config);

//	Parkspace_allocator::get_instance_references().parkspace_allocator_init(5, config);


//	Parkspace_db_manager& parkspaceDbManager=Parkspace_db_manager::get_instance_references();


//    Parkspace_allocation_communicator *p_parkspace_allocation_communicater = Parkspace_allocation_communicator::get_instance_pointer();
//    Parkspace_allocator *p_parkspace_allocator = Parkspace_allocator::get_instance_pointer();
//
//    p_parkspace_allocator->parkspace_allocator_init(4, config);
//    p_parkspace_allocation_communicater->communication_bind("tcp://192.168.2.115:7001");

    // p_parkspace_allocation_communicater->communication_bind("tcp://192.168.2.125:7001");
    // p_parkspace_allocation_communicater->communication_connect("tcp://127.0.0.1:7000");
//    p_parkspace_allocation_communicater->communication_run();

     // 初始化车位，创建三个车位
//     message::Parkspace_allocation_status_msg parkspace_status;
//     for (size_t i = 1; i < 1000; i++)
//     {
//         message::Parkspace_info* space = parkspace_status.add_parkspace_info();
//         space->set_parkspace_id(i);
//         space->set_index(i);
//         space->set_direction(message::Direction::eForward);
//         space->set_floor(2+i);
//         space->set_length(5.5);
//         space->set_width(2.2);
//         space->set_height(1.75);
//         space->set_parkspace_status(message::Parkspace_status::eParkspace_empty);
//     }
//     message::Base_info base_msg;
//     message::Error_manager error;
//     base_msg.set_msg_type(message::Message_type::eParkspace_allocation_response_msg);
//     base_msg.set_timeout_ms(1000);
//     base_msg.set_sender(message::Communicator::eParkspace);
//     base_msg.set_receiver(message::Communicator::eMain);
//     error.set_error_code(0);
//     parkspace_status.mutable_base_info()->CopyFrom(base_msg);
//     parkspace_status.mutable_error_manager()->CopyFrom(error);
//	parkspaceDbManager.update_all_parkspace_info(parkspace_status);
//    int k=1;
//    while(1) {
        // message::Parkspace_info space;
        // space.set_parkspace_id(3);
        // space.set_index(k);
        // space.set_direction(message::Direction::eForward);
        // space.set_floor(k*3);
        // space.set_length(5500);
        // space.set_width(2200);
        // space.set_height(k*400);
        // space.set_parkspace_status(message::Parkspace_status::eParkspace_occupied);
        // p_parkspace_allocator->update_parkspace_status(3, space);
//        sleep(1);
//        k++;
//    }
//	p_parkspace_allocation_communicater->communication_uninit();
//	Parkspace_allocator::get_instance_references().parkspace_allocator_uninit();
//    p_parkspace_allocator->parkspace_allocator_uninit();
    return 0;
}
